unit UnidadGPartes;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, Mask, Buttons, ExtCtrls, db, ComCtrls, Grids, DBGrids,
  ToolWin, Menus, ActnList, variants;

type
  TFormParteG = class(TForm)
    Panel1: TPanel;
    BCancelar: TBitBtn;
    GCabeza: TGroupBox;
    Label8: TLabel;
    BSeleccionarFecha: TSpeedButton;
    Label17: TLabel;
    BSeleccionar: TSpeedButton;
    DBText1: TDBText;
    txtFecha: TDBEdit;
    TxtCodigoCuadrilla: TDBEdit;
    GDetalle: TPanel;
    Tabla: TDBGrid;
    ActionList1: TActionList;
    ActNuevo: TAction;
    ActEliminar: TAction;
    ActModificar: TAction;
    ActRefrescar: TAction;
    PopupMenu1: TPopupMenu;
    Aadir1: TMenuItem;
    Modificar1: TMenuItem;
    Eliminar1: TMenuItem;
    N1: TMenuItem;
    Refrescar1: TMenuItem;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    Panel2: TPanel;
    DBText2: TDBText;
    Label9: TLabel;
    BAceptar: TBitBtn;
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure BSeleccionarFechaClick(Sender: TObject);
    procedure txtFechaKeyPress(Sender: TObject; var Key: Char);
    procedure DBEdit7KeyPress(Sender: TObject; var Key: Char);
    procedure DBEdit13KeyPress(Sender: TObject; var Key: Char);
    procedure BSeleccionarClick(Sender: TObject);
    procedure TxtCodigoCuadrillaKeyPress(Sender: TObject;
  var Key: Char);
    procedure txtFechaExit(Sender: TObject);
    procedure ActNuevoExecute(Sender: TObject);
    procedure ActRefrescarExecute(Sender: TObject);
    procedure ordenar (campo : string; campoFijo : string);
    procedure ActModificarExecute(Sender: TObject);
    procedure TablaDblClick(Sender: TObject);
    procedure ActEliminarExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormParteG: TFormParteG;
const
  ventana = 'Parte';
  ventanas = 'Partes';

implementation

uses UnidadDatos, UnidadMenuPrincipal, UnidadCalendario, UnidadSeleccion,
  UnidadGPartesEmpleado, DBTables;

{$R *.DFM}

procedure TFormParteG.BCancelarClick(Sender: TObject);
begin
  close;
end;

procedure TFormParteG.BAceptarClick(Sender: TObject);
begin
  if (TxtFecha.Text = '') then
  begin
    messagedlg ('Debe introducir la fecha del ' + ventana,
        mtinformation, [mbok], 0);
    txtFecha.setfocus;
    exit;
  end;
  if datos.TPartesCuadrilla.Value = '' then
  begin
    messagedlg ('No existe ninguna cuadrilla con el cdigo: ' +
        TxtCodigoCuadrilla.text + '.', mterror,[mbok],0);
    TxtCodigoCuadrilla.SelectAll;
    TxtCodigoCuadrilla.setfocus;
    exit;
  end;
  if datos.TPartes.State  in [dsinsert, dsedit] then
  begin
    try
      datos.TPartes.Post; //validar
    except
      TxtCodigoCuadrilla.setfocus;
      raise;
      exit;
    end;
  end;
  if MessageDlg('Desea aadir obreros al parte actual?',
      mtConfirmation, [mbyes,mbno],0) = mryes then
  begin
    ActNuevoExecute(nil);
  end;
  GDetalle.Enabled := true;
  ActNuevo.Enabled := true;
  ActModificar.Enabled := true;
  ActEliminar.Enabled := true;
  ActRefrescar.Enabled := true;
end;

procedure TFormParteG.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  action := cafree;
end;                                                                                                                                                                                                                                                                                                                                                                      

procedure TFormParteG.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TFormParteG.FormShow(Sender: TObject);
begin
  datos.tPartes.open;
  if formmenuprincipal.accion = 'nuevo' then
  begin
    caption := 'Nuevo ' + ventana + '...';
    Datos.TCPartesEmpleadosF.Close;
    datos.TPartes.Insert;
    datos.TPartes.FieldByName('Fecha').Value := date;
  end;
  if formmenuprincipal.accion = 'modificar' then
  begin
    caption := 'Modificar ' + ventana + '...';
    ActRefrescarExecute(nil);
    GDetalle.Enabled := true;
    ActNuevo.Enabled := true;
    ActEliminar.Enabled := true;
    ActModificar.Enabled := true;
    ActRefrescar.Enabled := true;
  end;
  if formmenuprincipal.accion = 'zoom' then
  begin
    datos.TPartes.locate ('Codigo', formmenuprincipal.codigo,[]);
    caption := 'Visualizar ' + ventana + '...';
    ActRefrescarExecute(nil);
    baceptar.Visible := false;
    bcancelar.SetFocus;
    BSeleccionar.Visible := false;
    BSeleccionarFecha.Visible := false;
    ActNuevo.Enabled := true;
    ActEliminar.Enabled := true;
    ActModificar.Enabled := true;
    ActRefrescar.Enabled := true;
    BCancelar.SetFocus;
  end;
end;

procedure TFormParteG.BSeleccionarFechaClick(Sender: TObject);
begin
  application.createform(tformCalendario, formCalendario);
  formCalendario.ShowModal;
  if formmenuprincipal.claveelegida <> '' then
    if FormMenuPrincipal.claveelegida <> '' then
      txtFecha.Text := formmenuprincipal.claveelegida;
end;

procedure TFormParteG.txtFechaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = '+' then
    BSeleccionarFechaClick(nil);
end;

procedure TFormParteG.DBEdit7KeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TFormParteG.DBEdit13KeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TFormParteG.BSeleccionarClick(Sender: TObject);
begin
  TxtCodigoCuadrilla.SetFocus;
  application.createform(tformseleccion, formseleccion);
  formseleccion.ActNuevo.Enabled := true;
  formseleccion.tag := 20;
  formseleccion.ShowModal;
  if formmenuprincipal.claveelegida <> '' then
    TxtCodigoCuadrilla.Text := formmenuprincipal.claveelegida;
  datos.DPartes.DataSet.edit;
end;

procedure TFormParteG.TxtCodigoCuadrillaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '+' then
  begin
    key := chr(0);
    BSeleccionarClick(nil);
  end;
end;

procedure TFormParteG.txtFechaExit(Sender: TObject);
begin
//   BAceptar.SetFocus;
end;

procedure TFormParteG.ActNuevoExecute(Sender: TObject);
begin
  tag := 1; //nuevo
  application.createform(TFormPartesEmpleadoG, FormPartesEmpleadoG);
  FormPartesEmpleadoG.ShowModal;
  ActRefrescarExecute(nil);
end;

procedure tFormParteG.ordenar (campo : string; campoFijo : string);
var
  lugar : string;
begin
  lugar := '';
  with datos.TC do
  begin
    close;
    Datos.TC.DatabaseName := 'Pagos';
    sql.Clear;
    sql.add ('select SUM(p.Importe) ImporteTotal');
    sql.add ('from ' + ctDetallePartes + ' p');
    sql.add ('where p.CodigoParte = :pCodigoParte');
    ParamByName('pCodigoParte').DataType := ftInteger;
    ParamByName('pCodigoParte').Value := datos.tpartescodigo.value;
    try
      open;
    except
      raise;
    end;
    if (Datos.TPartes.State <> dsedit) and (Datos.TPartes.State <> dsinsert) then
      Datos.TPartes.Edit;
    if varisnull(FieldByName('ImporteTotal').Value) then
      Datos.TPartesImporteTotal.Value := 0
    else
      Datos.TPartesImporteTotal.Value := fieldbyname('ImporteTotal').Value;
    Datos.TPartes.Post;
    close;
    Datos.TC.DatabaseName := '';
  end;
  with datos.TCPartesEmpleadosF do
  begin
    sql.Clear;
    sql.add ('select p.*, e.Nombre Obrero');
    sql.add ('from ' + ctDetallePartes + ' p, ' + ctEmpleado  + ' e');
    sql.add ('where p.CodigoEmpleado = e.Codigo and p.CodigoParte = :pCodigoParte');
    sql.add ('order by ' + campo + ', ' +  campofijo);
    ParamByName('pCodigoParte').DataType := ftInteger;
    ParamByName('pCodigoParte').Value := datos.tpartescodigo.value;
    try
      open;
    except
      raise;
    end;
  end;
end;

procedure TFormParteG.ActRefrescarExecute(Sender: TObject);
begin
  ordenar('Codigo', 'Nombre')
end;

procedure TFormParteG.ActModificarExecute(Sender: TObject);
begin
  tag := 2; //modificar
  if datos.TCPartesEmpleadosF.RecordCount <= 0 then
    messagedlg ('No hay datos.', mtinformation,[mbok],0)
  else
  begin
    if not varisnull(datos.TCPartesEmpleadosF.fieldbyname('Codigo').value) then
    begin
      formmenuprincipal.accion := 'modificar';
      datos.TPartesEmpleados.Active := true;
      datos.TPartesEmpleados.locate ('Codigo',
          datos.TCPartesEmpleadosF.fieldbyname('Codigo').value,[]);
      datos.TPartesEmpleados.edit;
      application.createform(TFormPartesEmpleadoG, FormPartesEmpleadoG);
      FormPartesEmpleadoG.ShowModal;
      ActRefrescarExecute(nil);
    end;
  end;
end;

procedure TFormParteG.TablaDblClick(Sender: TObject);
begin
  if (txtFecha.Text <> '') and (TxtCodigoCuadrilla.Text <> '') then
    ActModificarExecute(nil);
end;

procedure TFormParteG.ActEliminarExecute(Sender: TObject);
var
  nombre : String;
begin
  if datos.TCPartesEmpleadosF.RecordCount <= 0 then
    messagedlg ('No hay datos.', mtinformation,[mbok],0)
  else
  begin
    datos.tc.close;
    datos.TPartesEmpleados.Active := true;
    datos.TPartesEmpleados.locate('Codigo',
        datos.TCPartesEmpleadosF.fieldbyname('Codigo').value, []);
    if not varisnull(datos.TCPartesEmpleadosFObrero.Value) then
      nombre := datos.TCPartesEmpleadosFObrero.Value
    else
      nombre := '';
    if messagedlg ('Est seguro que desea eliminar el empleado ' +
        nombre + '?', mtconfirmation,[mbyes,mbno],0)=mryes then
    begin
      try
        datos.TPartesEmpleados.delete;
        ActRefrescarExecute(nil);
      except
        raise;
      end;
    end;
  end;
end;

end.
