unit UnidadGPartesEmpleado;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, Mask, Buttons, ExtCtrls, db, ComCtrls, variants;

type
  TFormPartesEmpleadoG = class(TForm)
    Panel1: TPanel;
    TxtCodigo: TDBEdit;
    Label1: TLabel;
    BCancelar: TBitBtn;
    BAceptar: TBitBtn;
    Label9: TLabel;
    DBEdit7: TDBEdit;
    Label15: TLabel;
    txtHora: TDBEdit;
    Label16: TLabel;
    DBMemo1: TDBMemo;
    Label17: TLabel;
    BSeleccionar: TSpeedButton;
    DBText1: TDBText;
    TxtCodigoCuadrilla: TDBEdit;
    BSeleccionarObrero: TSpeedButton;
    DBText2: TDBText;
    Label2: TLabel;
    DBEdit1: TDBEdit;
    Label3: TLabel;
    DBText3: TDBText;
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure TxtCodigoExit(Sender: TObject);
    procedure DBEdit7KeyPress(Sender: TObject; var Key: Char);
    procedure txtHoraKeyPress(Sender: TObject; var Key: Char);
    procedure BSeleccionarClick(Sender: TObject);
    procedure TxtCodigoCuadrillaKeyPress(Sender: TObject; var Key: Char);
    procedure CalcularImporte();
    procedure txtHoraExit(Sender: TObject);
    procedure TxtCodigoKeyPress(Sender: TObject; var Key: Char);
    procedure BSeleccionarObreroClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormPartesEmpleadoG: TFormPartesEmpleadoG;
const
  ventana = 'Empleado parte';
  ventanas = 'Empleados partes';

implementation

uses UnidadDatos, UnidadMenuPrincipal, UnidadCalendario, UnidadSeleccion,
  UnidadGPartes;

{$R *.DFM}

procedure TFormPartesEmpleadoG.BCancelarClick(Sender: TObject);
begin
  try
    datos.TPartesEmpleados.cancel;
  except
    //silenciosa
  end;
  close;
end;

procedure TFormPartesEmpleadoG.BAceptarClick(Sender: TObject);
begin
  if (TxtCodigo.Text = '') then
  begin
    messagedlg ('Debe introducir el cdigo del ' + ventana,
        mtinformation,[mbok],0);
    txtcodigo.setfocus;
    exit;
  end;
  if datos.TPartesEmpleados.State  in [dsinsert, dsedit] then
  begin
    try
      datos.TPartesEmpleados.Post; //validar
    except
      txtCODIGOcuadrilla.setfocus;
      raise;
    end;
  end;
  close;
end;

procedure TFormPartesEmpleadoG.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  action := cafree;
end;                                                                                                                                                                                                                                                                                                                                                                      

procedure TFormPartesEmpleadoG.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TFormPartesEmpleadoG.FormShow(Sender: TObject);
begin
  datos.TPartesEmpleados.open;
  if FormParteG.tag = 1 then //Nuevo
  begin
    caption := 'Nuevo ' + ventana + '...';
    datos.TPartesEmpleados.Insert;
    datos.TPartesEmpleados.FieldByName('CodigoParte').Value :=
        Datos.TPartesCodigo.Value;
    datos.TPartesEmpleados.FieldByName('CodigoCuadrilla').Value :=
        Datos.TPartesCodigoCuadrilla.Value;
    datos.TPartesEmpleados.FieldByName('Fecha').Value :=
        Datos.TPartesFecha.Value;
    datos.TPartesEmpleados.FieldByName('Precio').Value := 0;
    datos.TPartesEmpleados.FieldByName('Importe').Value := 0;
    datos.TPartesEmpleados.FieldByName('ImporteCoche').Value := 0;
    datos.TPartesEmpleados.FieldByName('Horas').Value := 8;
  end;
  if FormParteG.tag = 2 then //Modificar
  begin
    txtcodigo.SetFocus;
    caption := 'Modificar ' + ventana + '...';
  end;
end;

procedure TFormPartesEmpleadoG.TxtCodigoExit(Sender: TObject);
begin
  if (formmenuprincipal.accion = 'nuevo') then
  begin
    if txtcodigo.text = '' then
    begin
      messagedlg ('El cdigo debe contener un valor.', mterror,[mbok],0);
      txtcodigo.SelectAll;
      txtcodigo.setfocus;
      exit;
    end;
  end;
  datos.TEmpleado.Open;
  if Datos.TEmpleado.Locate('Codigo', txtcodigo.Text,[]) then
  begin
    if not varisnull(datos.TEmpleadoPRECIOHORA.Value) then
    begin
      datos.TPartesEmpleadosPrecio.Value := datos.TEmpleadoPRECIOHORA.Value;
    end;
  end;
end;

procedure TFormPartesEmpleadoG.DBEdit7KeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TFormPartesEmpleadoG.txtHoraKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TFormPartesEmpleadoG.BSeleccionarClick(Sender: TObject);
begin
  application.createform(tformseleccion, formseleccion);
  formseleccion.ActNuevo.Enabled := true;
  formseleccion.tag := 20;
  formseleccion.ShowModal;
  if formmenuprincipal.claveelegida <> '' then
    TxtCodigoCuadrilla.Text := formmenuprincipal.claveelegida;
  Datos.DPartesEmpleados.DataSet.edit;
end;

procedure TFormPartesEmpleadoG.TxtCodigoCuadrillaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if FormMenuPrincipal.accion <> 'zoom' then
  begin
    if key = '+' then
    begin
      key := chr(0);
      BSeleccionarClick(nil);
    end;
  end;
end;

procedure TFormPartesEmpleadoG.CalcularImporte();
begin
  try
    datos.TPartesEmpleadosImporte.Value := (Datos.TPartesEmpleadosPrecio.Value *
        Datos.TPartesEmpleadosHoras.Value) +
        Datos.TPartesEmpleadosImporteCoche.Value;
  except
    txtHora.setfocus;
    raise
  end;
end;

procedure TFormPartesEmpleadoG.txtHoraExit(Sender: TObject);
begin
  CalcularImporte;
end;

procedure TFormPartesEmpleadoG.TxtCodigoKeyPress(Sender: TObject;
  var Key: Char);
begin
  if FormMenuPrincipal.accion <> 'zoom' then
  begin
    if key = '+' then
    begin
      key := chr(0);
      BSeleccionarObreroClick(nil);
    end;
  end;
end;

procedure TFormPartesEmpleadoG.BSeleccionarObreroClick(Sender: TObject);
begin
  application.createform(tformseleccion, formseleccion);
  formseleccion.ActNuevo.Enabled := true;
  if TxtCodigoCuadrilla.Text <> '' then
    formseleccion.tag := 30
  else
    formseleccion.tag := 10;
  formseleccion.ShowModal;
  if formmenuprincipal.claveelegida <> '' then
    TxtCodigo.Text := formmenuprincipal.claveelegida;
  Datos.DPartesEmpleados.DataSet.edit;    
end;

end.
