unit UnidadLocalizar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, db;

type
  TFormLocalizar = class(TForm)
    GComercial: TGroupBox;
    Op2: TRadioButton;
    Op1: TRadioButton;
    TxtBuscar: TEdit;
    Label1: TLabel;
    BCancelar: TBitBtn;
    Op3: TRadioButton;
    Op4: TRadioButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure BCancelarClick(Sender: TObject);
    procedure TxtBuscarChange(Sender: TObject);
    procedure TxtBuscarKeyPress(Sender: TObject; var Key: Char);
    procedure Op2KeyPress(Sender: TObject; var Key: Char);
    procedure Op1KeyPress(Sender: TObject; var Key: Char);
    procedure Op3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormLocalizar: TFormLocalizar;

implementation

uses UnidadDatos;

{$R *.DFM}

function esNumero (numero : string) : boolean;
begin
  try
    strtoint(numero);
    result := true;
  except
    result := false;
  end;
end;


procedure TFormLocalizar.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  screen.Cursor := crDefault;
  action := cafree;
end;

procedure TFormLocalizar.FormShow(Sender: TObject);
begin
  if tag = 10 then //comerciales
  begin
    Op1.Visible := true;
    Op1.caption := '&Nombre';
    Op2.Visible := true;
    Op2.caption := 'N&IF';
    Op3.Visible := true;
    Op3.caption := 'Cdig&o';
    Op4.Visible := true;
    Op4.caption := 'T&elfono';
    caption := 'Localizar comerciales...';
    GComercial.Visible := true;
  end;
  if tag = 20 then //pagos
  begin
    caption := 'Localizar pagos...';
    Op1.Visible := true;
    Op1.caption := '&Nombre';
    Op2.Visible := true;
    Op2.caption := 'Fecha &Pago';
    GComercial.Visible := true;
  end;
end;

procedure TFormLocalizar.BCancelarClick(Sender: TObject);
begin
  close;
end;

procedure TFormLocalizar.TxtBuscarChange(Sender: TObject);
begin
  if tag = 10 then  //Empleados
  begin
    //por nif
    if Op2.Checked then
      datos.TCEmpleado.Locate('NIF', txtbuscar.text,[lopartialkey,
          locaseinsensitive]);
    //por nombre
    if Op1.Checked then
      datos.TCEmpleado.Locate('Nombre', txtbuscar.text, [lopartialkey,
          locaseinsensitive]);
    //por codigo
    if Op3.Checked then
      datos.TCEmpleado.Locate('Codigo', txtbuscar.text, [lopartialkey,
          locaseinsensitive]);
    //por telfono
    if Op4.Checked then
      datos.TCEmpleado.Locate('Telefono', txtbuscar.text, [lopartialkey,
          locaseinsensitive]);
  end;
  if tag = 20 then  //pagos
  begin
    //por nombre
    if Op1.Checked then
      datos.TCPagos.Locate('Nombre', txtbuscar.text,[lopartialkey,
          locaseinsensitive]);
    //por fecha pago
    if Op2.Checked then
    begin
      try
        datos.TCPagos.Locate('FechaPago', txtbuscar.text, [lopartialkey,
            locaseinsensitive]);
      except
        //silenciosa
      end;
    end;
  end;
end;

procedure TFormLocalizar.TxtBuscarKeyPress(Sender: TObject; var Key: Char);
begin
  if key = char(13) then
  begin
    key := #0;
    BCancelarClick(nil);
  end;
end;

procedure TFormLocalizar.Op2KeyPress(Sender: TObject; var Key: Char);
begin
  if key = chr(13) then
    TxtBuscar.setfocus;
end;

procedure TFormLocalizar.Op1KeyPress(Sender: TObject; var Key: Char);
begin
  if key = chr(13) then
    TxtBuscar.setfocus;
end;

procedure TFormLocalizar.Op3Click(Sender: TObject);
begin
  txtbuscar.setfocus;
end;

end.
