unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ActnList, ImgList, Menus, ComCtrls, ToolWin, ExtCtrls,
  INIFILES, SHELLAPI;

type
  TformMenuPrincipal = class(TForm)
    txtResultado: TMemo;
    MainMenu1: TMainMenu;
    ActionList1: TActionList;
    actEmpleados: TAction;
    actPagos: TAction;
    actSalir: TAction;
    Archivo1: TMenuItem;
    Empleados1: TMenuItem;
    Empleados2: TMenuItem;
    N1: TMenuItem;
    Salir1: TMenuItem;
    StatusBar1: TStatusBar;
    actCalculadora: TAction;
    actAcercaDe: TAction;
    Herramientas1: TMenuItem;
    Calculadora1: TMenuItem;
    Ayuda1: TMenuItem;
    Acercade1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Empleados3: TMenuItem;
    Calcularperodo1: TMenuItem;
    Salir2: TMenuItem;
    N2: TMenuItem;
    Ventana1: TMenuItem;
    actCerrarTodas: TAction;
    actMinimizarTodas: TAction;
    Cerrartodas1: TMenuItem;
    actMinimizartodas1: TMenuItem;
    actMosaico: TAction;
    N3: TMenuItem;
    Mosaico1: TMenuItem;
    actCascada: TAction;
    Cascada1: TMenuItem;
    actOrdenarVentanas: TAction;
    actAbrirTodas: TAction;
    Abrirtodas1: TMenuItem;
    Ordenariconos1: TMenuItem;
    ControlBar1: TControlBar;
    BH: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ImageList1: TImageList;
    actCalcularPeriodo: TAction;
    CalcularPerodo2: TMenuItem;
    N4: TMenuItem;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    CalcularPerodo3: TMenuItem;
    N5: TMenuItem;
    actCuadrillas: TAction;
    ToolButton7: TToolButton;
    Cuadrillas1: TMenuItem;
    Cuadrillas2: TMenuItem;
    actPartesTrabajo: TAction;
    ToolButton8: TToolButton;
    Partesdetrabajo1: TMenuItem;
    Partesdetrabajo2: TMenuItem;
    actCarga: TAction;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    Cargadedatosimportacin1: TMenuItem;
    N6: TMenuItem;
    procedure actSalirExecute(Sender: TObject);
    procedure actEmpleadosExecute(Sender: TObject);
    procedure actCerrarTodasExecute(Sender: TObject);
    procedure actMinimizarTodasExecute(Sender: TObject);
    procedure actMosaicoExecute(Sender: TObject);
    procedure actCascadaExecute(Sender: TObject);
    procedure actOrdenarVentanasExecute(Sender: TObject);
    procedure actAbrirTodasExecute(Sender: TObject);
    procedure actPagosExecute(Sender: TObject);

    function Fecha (dia, mes, ano : word) : tdate;
    function Mes (mes : integer) : string;
    function calcularBilletes(Cantidad : double) : string;
    procedure actCalcularPeriodoExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure actAcercaDeExecute(Sender: TObject);
    procedure actCalculadoraExecute(Sender: TObject);
    procedure actCuadrillasExecute(Sender: TObject);
    procedure actPartesTrabajoExecute(Sender: TObject);
    procedure actCargaExecute(Sender: TObject);

  private
    { Private declarations }
  public
    Accion : string;
    Codigo : string;
    ClaveElegida : string;
    { Public declarations }
  end;
  const
    ctEmpleado = 'Empleados';
    ctCuadrilla = 'Cuadrillas';
    ctPartes = 'Partes';
    ctDetallePartes = 'PartesDetalle';
    ctPagos = 'Pagos';

var
  formMenuPrincipal: TformMenuPrincipal;
  nombreEmpresa : string;

implementation

uses UnidadEmpleado, UnidadPagos, UnidadCalcularPeriodo, About,
  UnidadCuadrilla, UnidadPartes, UnidadCargas;

{$R *.dfm}


function tformmenuprincipal.Fecha (dia, mes, ano : word) : tdate;
begin
  result := EncodeDate (ano,mes,dia);
end;

function tformmenuprincipal.Mes (mes : integer) : string;
begin
  case mes of
    1 : result := 'Enero';
    2 : result := 'Febrero';
    3 : result := 'Marzo';
    4 : result := 'Abril';
    5 : result := 'Mayo';
    6 : result := 'Junio';
    7 : result := 'Julio';
    8 : result := 'Agosto';
    9 : result := 'Septiembre';
    10 : result := 'Octubre';
    11 : result := 'Noviembre';
    12 : result := 'Diciembre';
  end;
end;

function TformMenuPrincipal.calcularBilletes(Cantidad : double) : string;
var
  C : array[1..15] of double;
  M : array[1..15] of string;
  S : array[1..15] of double;
  i : integer;
  resultado : string;
begin
  try
    resultado := '';
    c[1] := 50000;
    m[1] := '500 euros (Billete)';
    c[2] := 20000;
    m[2] := '200 euros (Billete)';
    c[3] := 10000;
    m[3] := '100 euros (Billete)';
    c[4] := 5000;
    m[4] := '50 euros (Billete)';
    c[5] := 2000;
    m[5] := '20 euros (Billete)';
    c[6] := 1000;
    m[6] := '10 euros (Billete)';
    c[7] := 500;
    m[7] := '5 euros (Billete)';
    c[8] := 200;
    m[8] := '2 euros (Moneda)';
    c[9] := 100;
    m[9] := '1 euro (Moneda)';
    c[10] := 50;
    m[10] := '50 cntimos (Moneda)';
    c[11] := 20;
    m[11] := '20 cntimos (Moneda)';
    c[12] := 10;
    m[12] := '10 cntimos (Moneda)';
    c[13] := 5;
    m[13] := '5 cntimos (Moneda)';
    c[14] := 2;
    m[14] := '2 cntimos (Moneda)';
    c[15] := 1;
    m[15] := '1 cntimo (Moneda)';

    //Pasa el total a pagar a cntimos
    cantidad := cantidad * 100;
    cantidad := int(cantidad);
    for i := 1 to 15 do
    begin
      s[i] := int(cantidad / c[i]);
      cantidad := cantidad - s[i] * c[i];
    end;
    for i := 1 to 15 do
    begin
      if s[i] <> 0 then
      begin
        if resultado <> '' then
          resultado := resultado + chr(13) + floattostr(s[i]) + ' -> ' + m[i]
        else
          resultado := floattostr(s[i]) + ' -> ' + m[i];
      end;
    end;
    result := resultado;
  except
    result := 'ERROR AL CALCULAR';
  end;
end;

procedure TformMenuPrincipal.actSalirExecute(Sender: TObject);
begin
  actCerrarTodasExecute(nil);
  close;
end;


procedure TformMenuPrincipal.actEmpleadosExecute(Sender: TObject);
var
  f : TForm;
begin
  screen.cursor := crhourglass;
  lockwindowupdate(application.mainform.handle);
  try
    F := application.findcomponent('formEmpleados') as tform;
    if Assigned(F) then
    begin
      if f.WindowState = wsminimized then
        f.windowstate := wsmaximized;
      f.bringtofront;
      screen.cursor := crdefault;
    end
    else
    begin
      application.createform (TformEmpleados, formEmpleados);
      formEmpleados.WindowState := wsmaximized;
    end;
  finally
    lockwindowupdate(0);
  end;
end;


procedure TformMenuPrincipal.actCerrarTodasExecute(Sender: TObject);
Var
   N: Integer;
begin
  For N := 0 To MDIChildCount-1 Do
    MDIChildren[n].Close;
end;

procedure TformMenuPrincipal.actMinimizarTodasExecute(Sender: TObject);
Var
   N: Integer;
begin
  // Recorrer todas las ventanas
  For N := 0 To MDIChildCount-1 Do
    MDIChildren[N].WindowState := wsMinimized;
  if mdichildcount > 0 then
    ActiveMDIChild.WindowState := wsMinimized;
end;

procedure TformMenuPrincipal.actMosaicoExecute(Sender: TObject);
begin
  tile;
end;

procedure TformMenuPrincipal.actCascadaExecute(Sender: TObject);
begin
  cascade;
end;

procedure TformMenuPrincipal.actOrdenarVentanasExecute(Sender: TObject);
begin
  arrangeicons;
end;

procedure TformMenuPrincipal.actAbrirTodasExecute(Sender: TObject);
Var
   N: Integer;
begin
  For N := 0 To MDIChildCount-1 Do
     MDIChildren[N].WindowState := wsNormal;
end;


procedure TformMenuPrincipal.actPagosExecute(Sender: TObject);
var
  f : TForm;
begin
  screen.cursor := crhourglass;
  lockwindowupdate(application.mainform.handle);
  try
    F := application.findcomponent('formPagos') as tform;
    if Assigned(F) then
    begin
      if f.WindowState = wsminimized then
        f.windowstate := wsmaximized;
      f.bringtofront;
      screen.cursor := crdefault;
    end
    else
    begin
      application.createform (TformPagos, formPagos);
      formPagos.WindowState := wsmaximized;
    end;
  finally
    lockwindowupdate(0);
  end;
end;

procedure TformMenuPrincipal.actCalcularPeriodoExecute(Sender: TObject);
var
  F : TForm;
begin
  if MDIChildCount>0 then
    messagedlg ('Antes de abrir CALCULAR PERODO debe cerrar todas las ventanas.',mtinformation,[mbok],0)
  else
  begin
    F := application.findcomponent('formcalcularperiodo') as TForm;
    if Assigned(F) then
      f.showmodal
    else
    begin
      application.createform(Tformcalcularperiodo, formcalcularperiodo);
      formcalcularperiodo.showmodal;
    end;
  end;
end;

procedure TformMenuPrincipal.FormShow(Sender: TObject);
begin
  with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
  try
    nombreEmpresa := readString('Empresa', 'Nombre', 'PRUEBAS');
  finally
    Free;
  end;
end;

procedure TformMenuPrincipal.actAcercaDeExecute(Sender: TObject);
begin
  with tformacercade.Create(nil) do
  try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TformMenuPrincipal.actCalculadoraExecute(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('calc.exe'), Nil, Nil, SW_NORMAL);
end;

procedure TformMenuPrincipal.actCuadrillasExecute(Sender: TObject);
var
  f : TForm;
begin
  screen.cursor := crhourglass;
  lockwindowupdate(application.mainform.handle);
  try
    F := application.findcomponent('formCuadrillas') as tform;
    if Assigned(F) then
    begin
      if f.WindowState = wsminimized then
        f.windowstate := wsmaximized;
      f.bringtofront;
      screen.cursor := crdefault;
    end
    else
    begin
      application.createform (TformCuadrillas, formCuadrillas);
      formCuadrillas.WindowState := wsmaximized;
    end;
  finally
    lockwindowupdate(0);
  end;
end;

procedure TformMenuPrincipal.actPartesTrabajoExecute(Sender: TObject);
var
  f : TForm;
begin
  screen.cursor := crhourglass;
  lockwindowupdate(application.mainform.handle);
  try
    F := application.findcomponent('formPartes') as tform;
    if Assigned(F) then
    begin
      if f.WindowState = wsminimized then
        f.windowstate := wsmaximized;
      f.bringtofront;
      screen.cursor := crdefault;
    end
    else
    begin
      application.createform (TformPartes, formPartes);
      formPartes.WindowState := wsmaximized;
    end;
  finally
    lockwindowupdate(0);
  end;
end;

procedure TformMenuPrincipal.actCargaExecute(Sender: TObject);
begin
  with tformcargas.Create(nil) do
  try
    ShowModal;
  finally
    Free;
  end;
end;

end.
