unit UnidadSeleccion;
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, ToolWin, Grids, DBGrids, Db, DBTables,
  ActnList, Menus,Variants;

type
  TFormSeleccion = class(TForm)
    Tabla: TDBGrid;
    Panel1: TPanel;
    TC: TQuery;
    DC: TDataSource;
    ActionList1: TActionList;
    ActSeleccionar: TAction;
    ActCerrar: TAction;
    TxtBuscar: TEdit;
    LB: TLabel;
    GroupBox1: TGroupBox;
    Op1: TRadioButton;
    Op2: TRadioButton;
    Op3: TRadioButton;
    Op4: TRadioButton;
    PopupMenu1: TPopupMenu;
    Seleccionar1: TMenuItem;
    Salir1: TMenuItem;
    N1: TMenuItem;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ActNuevo: TAction;
    ActRefrescar: TAction;
    Nuevo1: TMenuItem;
    Refrescar1: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);

    procedure seleccionar ();
    procedure ActCerrarExecute(Sender: TObject);
    procedure TxtBuscarChange(Sender: TObject);
    procedure TxtBuscarKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure TxtBuscarKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ActNuevoExecute(Sender: TObject);
    procedure ActRefrescarExecute(Sender: TObject);
    procedure ActSeleccionarExecute(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormSeleccion: TFormSeleccion;

implementation

uses UnidadMenuPrincipal, UnidadGEmpleado, UnidadGCuadrilla, UnidadDatos;

{$R *.DFM}

procedure TFormSeleccion.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  tc.close;
  screen.cursor := crdefault;
  action := cafree;
end;

procedure TFormSeleccion.TablaKeyPress(Sender: TObject; var Key: Char);
begin
  if (key = 'c') or (key = 'C') or (key = chr(13))then
    actseleccionarexecute(nil);
end;

procedure TFormSeleccion.FormShow(Sender: TObject);
begin
  formmenuprincipal.claveelegida := '';
  ActRefrescarexecute(nil);
  txtbuscar.setfocus;
end;

procedure tformseleccion.seleccionar ();
begin
  if tag IN [10, 20, 30] then //Empleados, cuadrillas
  begin
    if not varisnull(tc.fieldbyname('Codigo').value) then
      formmenuprincipal.claveelegida :=
          tc.fieldbyname('Codigo').value
  end;
  close;
end;

procedure TFormSeleccion.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TFormSeleccion.TxtBuscarChange(Sender: TObject);
begin
  if (tag = 10) or (tag = 30) then //empleados
  begin
    if Op1.Checked then //nombre
    begin
      try
        tc.Locate ('Nombre', txtbuscar.text, [loCaseInsensitive, loPartialKey]);
      except
        //silenciosa
      end;
    end;
    if Op2.Checked then  //cdigo
    begin
      try
        tc.Locate ('Codigo', txtbuscar.text, [loCaseInsensitive, loPartialKey]);
      except
        //silenciosa
      end;
    end;
    if Op3.Checked then //DNI
    begin
      try
        tc.Locate ('NIF', txtbuscar.text, [loCaseInsensitive, loPartialKey]);
      except
        //silenciosa
      end;
    end;
    if Op4.Checked then //N SS
    begin
      try
        tc.Locate ('NumeroSeguridadSocial', txtbuscar.text, [loCaseInsensitive, loPartialKey]);
      except
        //silenciosa
      end;
    end;
  end;
  if (tag = 20) then //Cuadrillas
  begin
    if Op1.Checked then //nombre
    begin
      try
        tc.Locate ('Nombre', txtbuscar.text, [loCaseInsensitive, loPartialKey]);
      except
        //silenciosa
      end;
    end;
    if Op2.Checked then  //cdigo
    begin
      try
        tc.Locate ('Codigo', txtbuscar.text, [loCaseInsensitive, loPartialKey]);
      except
        //silenciosa
      end;
    end;
  end;
end;

procedure TFormSeleccion.TxtBuscarKeyPress(Sender: TObject; var Key: Char);
begin
  if key = chr(13) then
  begin
    key := #0;
    tabla.setfocus;
  end;
end;

procedure TFormSeleccion.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = chr(27) then  //escape
    ActCerrarExecute(nil);
end;

procedure TFormSeleccion.TxtBuscarKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = 40 then  //tecla cursor abajo
    tabla.setfocus;
end;

procedure TFormSeleccion.ActNuevoExecute(Sender: TObject);
begin
  if (tag = 10) or (tag = 30) then //Empleado
  begin
    formmenuprincipal.accion := 'nuevo';
    application.createform(tformEmpleadoG, formEmpleadoG);
    formEmpleadoG.ShowModal;
  end;
  if tag = 20 then //Cuadrilla
  begin
    formmenuprincipal.accion := 'nuevo';
    application.createform(tformCuadrillaG, formCuadrillaG);
    formCuadrillaG.ShowModal;
  end;
  ActRefrescarExecute(nil);
end;

procedure TFormSeleccion.ActRefrescarExecute(Sender: TObject);
begin
  tc.close;
  tc.sql.clear;
  tc.DatabaseName := 'Pagos';
  if tag = 10 then //Empleados
  begin
    Caption := 'Seleccin de empleado...';
    tc.sql.add('SELECT c.Codigo, c.Nombre, c.NIF, c.NumeroSeguridadSocial');
    tc.sql.add('FROM ' + ctEmpleado + ' c');
    op1.visible := true;
    op2.visible := true;
    op3.visible := true;
    op4.visible := true;
    op1.caption := '&Nombre';
    op2.caption := 'Cdig&o';
    op3.caption := 'NIF';
    op4.caption := 'N S.S.';
    if Op1.Checked then  //Nombre
    begin
      tc.sql.add('Order by Nombre');
      lb.Caption := '&Buscar por Nombre';
    end;
    if Op2.Checked then  //codigo
    begin
      lb.Caption := '&Buscar por Cdigo';
      tc.sql.add('Order by codigo');
    end;
    if Op3.Checked then  //NIF
    begin
      lb.Caption := '&Buscar por NIF';
      tc.sql.add('Order by NIF');
    end;
    if Op4.Checked then  //N S.S.
    begin
      tc.sql.add('Order by NumeroSeguridadSocial');
      lb.Caption := '&Buscar por N S.S.';
    end;
  end;
  if tag = 20 then //Cuadrillas
  begin
    Caption := 'Seleccin de cuadrilla...';
    tc.sql.add('SELECT c.Codigo, c.Nombre');
    tc.sql.add('FROM ' + ctCuadrilla + ' c');
    op1.visible := true;
    op2.visible := true;
    op3.visible := false;
    op4.visible := False;
    op1.caption := '&Nombre';
    op2.caption := 'Cdig&o';
    if Op1.Checked then  //Nombre
    begin
      tc.sql.add('Order by Nombre');
      lb.Caption := '&Buscar por Nombre';
    end;
    if Op2.Checked then  //codigo
    begin
      lb.Caption := '&Buscar por Cdigo';
      tc.sql.add('Order by codigo');
    end;
  end;
  if tag = 30 then //Empleados filtrado por cuadrilla
  begin
    Caption := 'Seleccin de empleado...';
    tc.sql.add('SELECT e.Codigo, e.Nombre, e.NIF, e.NumeroSeguridadSocial');
    tc.sql.add('FROM ' + ctEmpleado + ' e');
    TC.SQL.Add('where e.codigocuadrilla = :pCodigoCuadrilla');
    TC.ParamByName('pCodigoCuadrilla').DataType := ftstring;
    TC.ParamByName('pCodigoCuadrilla').value :=  Datos.TPartesEmpleadosCodigoCuadrilla.Value;
    op1.visible := true;
    op2.visible := true;
    op3.visible := true;
    op4.visible := true;
    op1.caption := '&Nombre';
    op2.caption := 'Cdig&o';
    op3.caption := 'NIF';
    op4.caption := 'N S.S.';
    if Op1.Checked then  //Nombre
    begin
      tc.sql.add('Order by e.Nombre');
      lb.Caption := '&Buscar por Nombre';
    end;
    if Op2.Checked then  //codigo
    begin
      lb.Caption := '&Buscar por Cdigo';
      tc.sql.add('Order by e.codigo');
    end;
    if Op3.Checked then  //NIF
    begin
      lb.Caption := '&Buscar por NIF';
      tc.sql.add('Order by e.NIF');
    end;
    if Op4.Checked then  //N S.S.
    begin
      tc.sql.add('Order by e.NumeroSeguridadSocial');
      lb.Caption := '&Buscar por N S.S.';
    end;
  end;

  try
    tc.open;
  except
    raise;
  end;
  if tag IN [10, 20] then //empleados, cuadrillas
  begin
    tc.FieldByName('Codigo').DisplayLabel := 'Cdigo';
    tc.FieldByName('Codigo').DisplayWidth := 5;
    tc.FieldByName('Nombre').DisplayLabel := 'Nombre';
    tc.FieldByName('Nombre').DisplayWidth := 23;
  end;
  txtbuscar.setfocus;
end;

procedure TFormSeleccion.ActSeleccionarExecute(Sender: TObject);
begin
  seleccionar();
end;

end.
